var fs = require("fs"),
    path = require("path"),
    assert = require("assert");

[
 "../tests/01-events.js",
 "../tests/02-stream.js",
 "../tests/03-feed.js"
]
.map(require)
.forEach(function (test){
	describe(test.dir, function(){
		var dir = path.resolve(__dirname, "..", "tests", test.dir);

		//read files, load them, run them
		fs
		.readdirSync(dir)
		.filter(RegExp.prototype.test, /^[^\._]/) //ignore all files with a leading dot or underscore
		.map(function(name){
			return path.resolve(dir, name);
		})
		.map(require)
		.forEach(function(file){
			it(file.name, function(done){
				var repeated = false; //every test runs twice

				test.test(file, function(err, dom){
					assert.ifError(err);
					try {
						assert.deepEqual(file.expected, dom, "didn't get expected output");
					} catch(e){
						e.expected = JSON.stringify(file.expected, null, 2);
						e.actual = JSON.stringify(dom, null, 2);
						throw e;
					}

					if(repeated) done();
					else repeated = true;
				});
			});
		});
	});
});